# coding:utf-8
#

'''
   ordena2_insercao.py

   Dados um inteiro positivo n e uma sequência de n números inteiros,
   ordená-los crescentemene (e imprimi-los).

'''
#-----------------------------------------------------------------------

def main():
    # n = int(input("Digite o número de elementos da sequência: "))
    
    # seq = []  

    # for i in range(n):
    #     num = int(input("Digite um inteiro da sequência: "))
    #    seq.append(num)    

    ## Vamos considerar a sequencia seq abaixo (sem fazer leitura, ou gerar aleatoriamente):
    
    seq = [5, 20, 3, 2, 14, 1, 7, 9, 15, 4]

    n = 10 
    print("sequencia dada  =", seq)

    #  os elementos da lista seq serão rearranjados para que fiquem em ordem crescente
    
    ordenacao_por_insercao(seq) # chamada da funcao que ordena uma lista.
    
    print("\nLista de inteiros em ordem crescente: \n", seq)

    print("\nSequência de inteiros em ordem crescente:")
    for num in seq:
        print(num, end='  ')   
    print()

#------------------------------------------------------------------------

def ordenacao_por_insercao(lista):
    ''' (list) -> NoneType
       
    Recebe uma lista com todos os valores de mesmo tipo.
    Rearranja os elementos de lista em ordem crescente; ou seja,
    de modo que satisfaçam: lista[0] <= lista[1] <= ...
    '''
    
    print()
    print("----------lista =", lista)   # apenas para teste
    n = len(lista)
    
    for i in range(1, n):
        ######## Queremos inserir lista[i] em lista[0...i]
        ######## de modo que lista[0...i] fique ordenado crescentemente
        item = lista[i]  #### item é o elemento que queremos posicionar no lugar certo.
                         #### lista[0...i-1] está ordenada crescentemente
                         #### vamos procurar a partir da posição i-1 onde item deve se encaixar.
        j = i-1 
        while (j >= 0 and lista[j] > item): 
            lista[j+1] = lista[j]   # desloca o elemento da posicao j+1 para a posicao j.
            j = j-1                 # vai para a esquerda e continua procurando onde encaixar                             
        lista[j+1] = item
        print("i = %2d -- lista = %s" %(i, lista)) # apenas para teste   
        
#------------------------------------------------------------------------
main()
'''
     Ideia geral: manter a parte inicial ordenada (até i-1), 
      tomar o item X que está na posicao i 
      e procurar no trecho ordenado onde inserir esse item,
      de modo que a parte inicial até i fique ordenado crescentemente. 

   
   Exemplo (passo genérico):

      ordenado crescent.
   |---------------------- X ... .................................|
   0                       i                       
                     item = lista[i]

    procurar a partir da posicao i-1 (indo para a esquerda) onde inserir o item (= lista[i])


   Ex: Se temos           item 
                           |
       3, 7,  10, 15, 22, 9, 18, 45 ..........
       --------------- |  i 
                       j  item = lista[5] = 9 
                          procurar a partir da posicao j = i-1 = 4 
                          (indo para a esquerda) onde inserir o item = 9
                           Neste caso, lista[j]= lista[4]=22 > 9; 
                           entao colocamos 22 na posicao 5 (fazemos lista[5]= lista[4])
       3, 7, 10, 15, 22, 22, 18, 45 ........ <== Veja 22 está repetido 
                  |                               (não colocamos 9 antes de 22)
                 j=3
                 15 > 9; entao colocamos 15 na posicao 4:

       3, 7, 10, 15, 15, 22, 18  45 ....... <=== Veja 15 está repetido 
              |                                  (nao colocamos 9 antes de 15)
             j=2 
           10 > 9; entao colocamos 10 na posicao 3:

       3, 7, 10, 10, 15, 22, 18, 45 .......<==== Veja 10 está repetido 
          |                                      (nao colocamos 9 antes de 10)
          j=1
          7 (da posicao 1)  <=  9, então achamos onde inserir o 9.
                                Inserimos 9 na posicao 2 (=j+1); 
                                com isso, o 10 da posicao 2 deixa de existir
                                (o que é bom, pois tínhamos deixado dois 10's).
                                Ficamos com a sequencia:
                            
                                    
       3, 7, 9, 10, 15, 22, 18, 45 ........ <=== agora 9 ficou na posição certa (lista[2])
      ---------------------
       ordenado crescentem. 
         
       
     (Note que, se em vez de 9 tivéssemos  item = 30, por exemplo, a condicao do while iria dar False, 
      e 30 ficaria onde está mesmo (faríamos lista[5] = item = 30. ))

      3, 7, 10, 15, 22, 30, 18  45 ..........
      ---------------------  |
       ordenado crescentem.  i

     Repetimos o processo procurando na parte inicial (já ordenada), onde encaixar o 18.
    
     No 'for' mais externo, começamos com  i = 1,.., n-1
'''
